﻿Type=StaticCode
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
 Private Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private start As String
	Private fin As String
	Private sf As StringFunctions
	Private bs As String
	Private rect1 As Rect
	Private bcolor As Int
	Private fcolor As Int	

End Sub

'Description: Generates Code 128 barcode and saves it in the /pictures folder as "Code128.png" from where it can be loaded into for eg an ImageView
'
'Method of calling:
'success = Code128.Draw_Code128(message, back_color, fore_color)
'
'where 'success' = indication of successful encoding (0 = successful, 1 = not successful) - type Int
'successful = all input chars are numbers only
'where 'message' = message to be encoded - type String
'where 'back_color' = background color of the code - type Int
'where 'fore_color' = foreground color of the code (solid bar color) - type Int
'example of parameters to pass:
'message = "600106035982" (12 chars only. No check digit to be included. Check digit will be calculated and added automatically)
'back_color = Colors.Yellow
'fore_color = Colors.Black
Public Sub Draw_Code128 (message As String, back_color As Int, front_color As Int) As Int
  
  bcolor = back_color
  fcolor = front_color
  build_string(message)
  sf.Initialize
  
End Sub

Private Sub build_string(message As String)

Dim karak As String
Dim checkval As Int
Dim ck As Int
checkval = 0
bs = ""
start = "11010010000"	      'start in B
checkval = checkval + 104
bs = bs & start

For i = 1 To sf.Len(message)
  karak = sf.Mid(message,i,1)
  Select Case karak     'decimal values for ASCII chars
	Case Chr(32): bs = bs & "11011001100":ck = 32:checkval = checkval + i * 0
	Case Chr(212): bs = bs & "11011001100":ck = 32:checkval = checkval + i * 0
	Case Chr(33): bs = bs & "11001101100":ck = 33:checkval = checkval + i * 1
	Case Chr(34): bs = bs & "11001100110":ck = 34:checkval = checkval + i * 2
	Case Chr(35): bs = bs & "10010011000":ck = 35:checkval = checkval + i * 3
	Case Chr(36): bs = bs & "10010001100":ck = 36:checkval = checkval + i * 4
	Case Chr(37): bs = bs & "10001001100":ck = 37:checkval = checkval + i * 5
	Case Chr(38): bs = bs & "10011001000":ck = 38:checkval = checkval + i * 6
	Case Chr(39): bs = bs & "10011000100":ck = 39:checkval = checkval + i * 7
	Case Chr(40): bs = bs & "10001100100":ck = 40:checkval = checkval + i * 8
	Case Chr(41): bs = bs & "11001001000":ck = 41:checkval = checkval + i * 9
	Case Chr(42): bs = bs & "11001000100":ck = 42:checkval = checkval + i * 10
	Case Chr(43): bs = bs & "11000100100":ck = 43:checkval = checkval + i * 11
	Case Chr(44): bs = bs & "10110011100":ck = 44:checkval = checkval + i * 12
	Case Chr(45): bs = bs & "10011011100":ck = 45:checkval = checkval + i * 13
	Case Chr(46): bs = bs & "10011001110":ck = 46:checkval = checkval + i * 14
	Case Chr(47): bs = bs & "10111001100":ck = 47:checkval = checkval + i * 15
	Case Chr(48): bs = bs & "10011101100":ck = 48:checkval = checkval + i * 16
	Case Chr(49): bs = bs & "10011100110":ck = 49:checkval = checkval + i * 17
	Case Chr(50): bs = bs & "11001110010":ck = 50:checkval = checkval + i * 18
	Case Chr(51): bs = bs & "11001011100":ck = 51:checkval = checkval + i * 19
	Case Chr(52): bs = bs & "11001001110":ck = 52:checkval = checkval + i * 20
	Case Chr(53): bs = bs & "11011100100":ck = 53:checkval = checkval + i * 21
	Case Chr(54): bs = bs & "11001110100":ck = 54:checkval = checkval + i * 22
	Case Chr(55): bs = bs & "11101101110":ck = 55:checkval = checkval + i * 23
	Case Chr(56): bs = bs & "11101001100":ck = 56:checkval = checkval + i * 24
	Case Chr(57): bs = bs & "11100101100":ck = 57:checkval = checkval + i * 25
	Case Chr(58): bs = bs & "11100100110":ck = 58:checkval = checkval + i * 26
	Case Chr(59): bs = bs & "11101100100":ck = 59:checkval = checkval + i * 27
	Case Chr(60): bs = bs & "11100110100":ck = 60:checkval = checkval + i * 28
	Case Chr(61): bs = bs & "11100110010":ck = 61:checkval = checkval + i * 29
	Case Chr(62): bs = bs & "11011011000":ck = 62:checkval = checkval + i * 30
	Case Chr(63): bs = bs & "11011000110":ck = 63:checkval = checkval + i * 31
	Case Chr(64): bs = bs & "11000110110":ck = 64:checkval = checkval + i * 32
	Case Chr(65): bs = bs & "10100011000":ck = 65:checkval = checkval + i * 33
	Case Chr(66): bs = bs & "10001011000":ck = 66:checkval = checkval + i * 34
	Case Chr(67): bs = bs & "10001000110":ck = 67:checkval = checkval + i * 35
	Case Chr(68): bs = bs & "10110001000":ck = 68:checkval = checkval + i * 36
	Case Chr(69): bs = bs & "10001101000":ck = 69:checkval = checkval + i * 37
	Case Chr(70): bs = bs & "10001100010":ck = 70:checkval = checkval + i * 38
	Case Chr(71): bs = bs & "11010001000":ck = 71:checkval = checkval + i * 39
	Case Chr(72): bs = bs & "11000101000":ck = 72:checkval = checkval + i * 40
	Case Chr(73): bs = bs & "11000100010":ck = 73:checkval = checkval + i * 41
	Case Chr(74): bs = bs & "10110111000":ck = 74:checkval = checkval + i * 42
	Case Chr(75): bs = bs & "10110001110":ck = 75:checkval = checkval + i * 43
	Case Chr(76): bs = bs & "10001101110":ck = 76:checkval = checkval + i * 44
	Case Chr(77): bs = bs & "10111011000":ck = 77:checkval = checkval + i * 45
	Case Chr(78): bs = bs & "10111000110":ck = 78:checkval = checkval + i * 46
	Case Chr(79): bs = bs & "10001110110":ck = 79:checkval = checkval + i * 47
	Case Chr(80): bs = bs & "11101110110":ck = 80:checkval = checkval + i * 48
	Case Chr(81): bs = bs & "11010001110":ck = 81:checkval = checkval + i * 49
	Case Chr(82): bs = bs & "11000101110":ck = 82:checkval = checkval + i * 50
	Case Chr(83): bs = bs & "11011101000":ck = 83:checkval = checkval + i * 51
	Case Chr(84): bs = bs & "11011100010":ck = 84:checkval = checkval + i * 52
	Case Chr(85): bs = bs & "11011101110":ck = 85:checkval = checkval + i * 53
	Case Chr(86): bs = bs & "11101011000":ck = 86:checkval = checkval + i * 54
	Case Chr(87): bs = bs & "11101000110":ck = 87:checkval = checkval + i * 55
	Case Chr(88): bs = bs & "11100010110":ck = 88:checkval = checkval + i * 56
	Case Chr(89): bs = bs & "11101101000":ck = 89:checkval = checkval + i * 57
	Case Chr(90): bs = bs & "11101100010":ck = 90:checkval = checkval + i * 58
	Case Chr(91): bs = bs & "11100011010":ck = 91:checkval = checkval + i * 59
	Case Chr(92): bs = bs & "11101111010":ck = 92:checkval = checkval + i * 60
	Case Chr(93): bs = bs & "11001000010":ck = 93:checkval = checkval + i * 61
	Case Chr(94): bs = bs & "11110001010":ck = 94:checkval = checkval + i * 62
	Case Chr(95): bs = bs & "10100110000":ck = 95:checkval = checkval + i * 63
	Case Chr(96): bs = bs & "10100001100":ck = 96:checkval = checkval + i * 64
	Case Chr(97): bs = bs & "10010110000":ck = 97:checkval = checkval + i * 65
	Case Chr(98): bs = bs & "10010000110":ck = 98:checkval = checkval + i * 66
	Case Chr(99): bs = bs & "10000101100":ck = 99:checkval = checkval + i * 67
	Case Chr(100): bs = bs & "10000100110":ck = 100:checkval = checkval + i * 68
	Case Chr(101): bs = bs & "10110010000":ck = 101:checkval = checkval + i * 69
	Case Chr(102): bs = bs & "10110000100":ck = 102:checkval = checkval + i * 70
	Case Chr(103): bs = bs & "10011010000":ck = 103:checkval = checkval + i * 71
	Case Chr(104): bs = bs & "10011000010":ck = 104:checkval = checkval + i * 72
	Case Chr(105): bs = bs & "10000110100":ck = 105:checkval = checkval + i * 73
	Case Chr(106): bs = bs & "10000110010":ck = 106:checkval = checkval + i * 74
	Case Chr(107): bs = bs & "11000010010":ck = 107:checkval = checkval + i * 75
	Case Chr(108): bs = bs & "11001010000":ck = 108:checkval = checkval + i * 76
	Case Chr(109): bs = bs & "11110111010":ck = 109:checkval = checkval + i * 77
	Case Chr(110): bs = bs & "11000010100":ck = 110:checkval = checkval + i * 78
	Case Chr(111): bs = bs & "10001111010":ck = 111:checkval = checkval + i * 79
	Case Chr(112): bs = bs & "10100111100":ck = 112:checkval = checkval + i * 80
	Case Chr(113): bs = bs & "10010111100":ck = 113:checkval = checkval + i * 81
	Case Chr(114): bs = bs & "10010011110":ck = 114:checkval = checkval + i * 82
	Case Chr(115): bs = bs & "10111100100":ck = 115:checkval = checkval + i * 83
	Case Chr(116): bs = bs & "10011110100":ck = 116:checkval = checkval + i * 84
	Case Chr(117): bs = bs & "10011110010":ck = 117:checkval = checkval + i * 85
	Case Chr(118): bs = bs & "11110100100":ck = 118:checkval = checkval + i * 86
	Case Chr(119): bs = bs & "11110010100":ck = 119:checkval = checkval + i * 87
	Case Chr(120): bs = bs & "11110010010":ck = 120:checkval = checkval + i * 88
	Case Chr(121): bs = bs & "11011011110":ck = 121:checkval = checkval + i * 89
	Case Chr(122): bs = bs & "11011110110":ck = 122:checkval = checkval + i * 90
	Case Chr(123): bs = bs & "11110110110":ck = 123:checkval = checkval + i * 91
	Case Chr(124): bs = bs & "10101111000":ck = 124:checkval = checkval + i * 92
	Case Chr(125): bs = bs & "10100011110":ck = 125:checkval = checkval + i * 93
	Case Chr(126): bs = bs & "10001011110":ck = 126:checkval = checkval + i * 94
	Case Chr(200): bs = bs & "10111101000":ck = 200:checkval = checkval + i * 95
	Case Chr(201): bs = bs & "10111100010":ck = 201:checkval = checkval + i * 96
	Case Chr(202): bs = bs & "11110101000":ck = 202:checkval = checkval + i * 97
	Case Chr(203): bs = bs & "11110100010":ck = 203:checkval = checkval + i * 98
	Case Chr(204): bs = bs & "10111011110":ck = 204:checkval = checkval + i * 99
	Case Chr(205): bs = bs & "10111101110":ck = 205:checkval = checkval + i * 100
	Case Chr(206): bs = bs & "11101011110":ck = 206:checkval = checkval + i * 101
	Case Chr(207): bs = bs & "11110101110":ck = 207:checkval = checkval + i * 102
	Case Chr(208): bs = bs & "11010000100":ck = 208:checkval = checkval + i * 103
	Case Chr(209): bs = bs & "11010010000":ck = 209:checkval = checkval + i * 104
	Case Chr(210): bs = bs & "11010011100":ck = 210:checkval = checkval + i * 105
	Case Chr(211): bs = bs & "1100011101011":ck = 211:checkval = checkval + i * 106
'   Log("ck")
'	Log(ck)
  End Select
Next	
'Log ("checkval")
'Log(checkval)


checkval = checkval Mod 103
'  Log(checkval)
  Select Case checkval     'decimal values for ASCII chars
	Case 0: bs = bs & "11011001100"
	Case 1: bs = bs & "11001101100"
	Case 2: bs = bs & "11001100110"
	Case 3: bs = bs & "10010011000"
	Case 4: bs = bs & "10010001100"
	Case 5: bs = bs & "10001001100"
	Case 6: bs = bs & "10011001000"
	Case 7: bs = bs & "10011000100"
	Case 8: bs = bs & "10001100100"
	Case 9: bs = bs & "11001001000"
	Case 10: bs = bs & "11001000100"
	Case 11: bs = bs & "11000100100"
	Case 12: bs = bs & "10110011100"
	Case 13: bs = bs & "10011011100"
	Case 14: bs = bs & "10011001110"
	Case 15: bs = bs & "10111001100"
	Case 16: bs = bs & "10011101100"
	Case 17: bs = bs & "10011100110"
	Case 18: bs = bs & "11001110010"
	Case 19: bs = bs & "11001011100"
	Case 20: bs = bs & "11001001110"
	Case 21: bs = bs & "11011100100"
	Case 22: bs = bs & "11001110100"
	Case 23: bs = bs & "11101101110"
	Case 24: bs = bs & "11101001100"
	Case 25: bs = bs & "11100101100"
	Case 26: bs = bs & "11100100110"
	Case 27: bs = bs & "11101100100"
	Case 28: bs = bs & "11100110100"
	Case 29: bs = bs & "11100110010"
	Case 30: bs = bs & "11011011000"
	Case 31: bs = bs & "11011000110"
	Case 32: bs = bs & "11000110110"
	Case 33: bs = bs & "10100011000"
	Case 34: bs = bs & "10001011000"
	Case 35: bs = bs & "10001000110"
	Case 36: bs = bs & "10110001000"
	Case 37: bs = bs & "10001101000"
	Case 38: bs = bs & "10001100010"
	Case 39: bs = bs & "11010001000"
	Case 40: bs = bs & "11000101000"
	Case 41: bs = bs & "11000100010"
	Case 42: bs = bs & "10110111000"
	Case 43: bs = bs & "10110001110"
	Case 44: bs = bs & "10001101110"
	Case 45: bs = bs & "10111011000"
	Case 46: bs = bs & "10111000110"
	Case 47: bs = bs & "10001110110"
	Case 48: bs = bs & "11101110110"
	Case 49: bs = bs & "11010001110"
	Case 50: bs = bs & "11000101110"
	Case 51: bs = bs & "11011101000"
	Case 52: bs = bs & "11011100010"
	Case 53: bs = bs & "11011101110"
	Case 54: bs = bs & "11101011000"
	Case 55: bs = bs & "11101000110"
	Case 56: bs = bs & "11100010110"
	Case 57: bs = bs & "11101101000"
	Case 58: bs = bs & "11101100010"
	Case 59: bs = bs & "11100011010"
	Case 60: bs = bs & "11101111010"
	Case 61: bs = bs & "11001000010"
	Case 62: bs = bs & "11110001010"
	Case 63: bs = bs & "10100110000"
	Case 64: bs = bs & "10100001100"
	Case 65: bs = bs & "10010110000"
	Case 66: bs = bs & "10010000110"
	Case 67: bs = bs & "10000101100"
	Case 68: bs = bs & "10000100110"
	Case 69: bs = bs & "10110010000"
	Case 70: bs = bs & "10110000100"
	Case 71: bs = bs & "10011010000"
	Case 72: bs = bs & "10011000010"
	Case 73: bs = bs & "10000110100"
	Case 74: bs = bs & "10000110010"
	Case 75: bs = bs & "11000010010"
	Case 76: bs = bs & "11001010000"
	Case 77: bs = bs & "11110111010"
	Case 78: bs = bs & "11000010100"
	Case 79: bs = bs & "10001111010"
	Case 80: bs = bs & "10100111100"
	Case 81: bs = bs & "10010111100"
	Case 82: bs = bs & "10010011110"
	Case 83: bs = bs & "10111100100"
	Case 84: bs = bs & "10011110100"
	Case 85: bs = bs & "10011110010"
	Case 86: bs = bs & "11110100100"
	Case 87: bs = bs & "11110010100"
	Case 88: bs = bs & "11110010010"
	Case 89: bs = bs & "11011011110"
	Case 90: bs = bs & "11011110110"
	Case 91: bs = bs & "11110110110"
	Case 92: bs = bs & "10101111000"
	Case 93: bs = bs & "10100011110"
	Case 94: bs = bs & "10001011110"
	Case 95: bs = bs & "10111101000"
	Case 96: bs = bs & "10111100010"
	Case 97: bs = bs & "11110101000"
	Case 98: bs = bs & "11110100010"
	Case 99: bs = bs & "10111011110"
	Case 100: bs = bs & "10111101110"
	Case 101: bs = bs & "11101011110"
	Case 102: bs = bs & "11110101110"
	Case 103: bs = bs & "11010000100"
	Case 104: bs = bs & "11010010000"
	Case 105: bs = bs & "11010011100"
	Case 106: bs = bs & "1100011101011"
  End Select

fin = "1100011101011"	
bs = bs & fin
'Log (bs)
teken(message)

End Sub

Private Sub teken (message As String)

Dim b1 As Bitmap
Dim siz1 As Int
Dim qr_size As Int
siz1 = 9dip

qr_size = 0dip
For i = 1 To sf.len(bs)
  qr_size = qr_size + siz1
Next

b1.InitializeMutable(qr_size + 150dip ,Floor(qr_size / 3) + 150dip)      'This will set a border of 20dip around the image
                                                                   
Dim c As Canvas
Dim x As Int
Dim y As Int

c.initialize2(b1)
rect1.Initialize(0, 0, 0, 0)
rect1.Left = 0                                          'Set the size of the drawing area and fill it with WHITE
rect1.Right = qr_size + 150dip        
rect1.Top = 0            
rect1.Bottom = Floor(qr_size / 3) + 150dip        

c.DrawRect(rect1,bcolor,True,0)

x = 75dip     
y = 20dip  
		 
		 
For i = 1 To sf.len(bs)
  If sf.Mid(bs,i,1) = "0" Then
	rect1.Left = x       
	rect1.Right = x + siz1            
	rect1.Top = y            
	rect1.Bottom = Floor(qr_size / 3) + 65dip           	 
    c.DrawRect(rect1, bcolor, True, 5dip)  
    x = x + siz1
  Else If sf.Mid(bs,i,1) = "1" Then
	rect1.Left = x       
	rect1.Right = x + siz1           
	rect1.Top = y
    rect1.Bottom = Floor(qr_size / 3) + 65dip  
    c.DrawRect(rect1, fcolor, True, 5dip)  
    x = x + siz1
  End If
Next

Dim stretch_mess As String
stretch_mess = ""

For i=1 To sf.Len(message)
  stretch_mess = stretch_mess & sf.Mid(message,i,1)
  If i < sf.Len(message) Then
    stretch_mess = stretch_mess & "        "
  End If	
Next 

c.DrawText(stretch_mess,Floor(qr_size+150)/2, Floor(qr_size / 3) + 130dip,Typeface.DEFAULT_BOLD,50,Colors.Black,"CENTER")
'See Erel's posting at http://www.basic4ppc.com/android/forum/threads/saving-a-picture.10200/#post-56686 for detail of the code below
'Marginally changed to suite my requirements

Dim out As OutputStream
out = File.OpenOutput(File.DirRootExternal, "/pictures/Code128.png", False)
b1.WriteToStream(out, 100, "PNG")                                           'Export the generated bitmap to a PNG and save in in the pictures folder
out.flush                                                                   'Make sure nothing is stuck that should have been written
out.Close

'send the intent that asks the media scanner to scan the file
Dim a123 As Intent
a123.Initialize("android.intent.action.MEDIA_SCANNER_SCAN_FILE", _
    "file://" & File.Combine(File.DirRootExternal, "/pictures/Code128.png"))   '...so that the file is visible....    
Dim p As Phone
p.SendBroadcastIntent(a123)  

End Sub

