﻿Type=StaticCode
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
 Private Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Private start As String
	Private fin As String
	Private sf As StringFunctions
	Private bs As String
	Private rect1 As Rect
	Private bcolor As Int
	Private fcolor As Int

End Sub

'Description: Generates a 2 of 5 Interleaved barcode and saves it in the /pictures folder as "Code25I.png" from where it can be loaded into for eg an ImageView
'
'Method of calling:
'success = Code25I.Draw_Code25I(message, back_color, fore_color)
'
'where 'success' = indication of successful encoding (0 = successful, 1 = not successful) - type Int
'successful = all input chars are numbers only
'where 'message' = message to be encoded - type String
'where 'back_color' = background color of the code - type Int
'where 'fore_color' = foreground color of the code (solid bar color) - type Int
'example of parameters to pass:
'message = "600106035982" (12 chars only. No check digit to be included. Check digit will be calculated and added automatically)
'back_color = Colors.Yellow
'fore_color = Colors.Black
Public Sub Draw_Code25I (message As String, back_color As Int, front_color As Int) As Int

  Dim flag1, flag2 As Int
  sf.Initialize()
  bcolor = back_color
  fcolor = front_color
  flag1 = 0
  flag2 = 0
  If sf.len(message) Mod 2 = 1 Then                'uneven number of digits
    flag2 = 1
  End If  
  
  For i = 1 To sf.Len(message)
      If sf.Mid(message,i,1) <> "0" AND _
	     sf.Mid(message,i,1) <> "1" AND _
		 sf.Mid(message,i,1) <> "2" AND _
		 sf.Mid(message,i,1) <> "3" AND _
		 sf.Mid(message,i,1) <> "4" AND _
		 sf.Mid(message,i,1) <> "5" AND _
		 sf.Mid(message,i,1) <> "6" AND _
		 sf.Mid(message,i,1) <> "7" AND _
		 sf.Mid(message,i,1) <> "8" AND _
		 sf.Mid(message,i,1) <> "9"  Then
		 flag1 = 1
		 Exit
	  End If	   
	Next 
 
    If flag1 = 1 Then
   	  ToastMessageShow ("You are attempting to encode non-numeric characters", False)
    End If

   If flag1 = 0 AND flag2 = 1 Then                    'calculate and add a checksum to get an even number of digits
     Dim z As Double
	 Dim karak As String
	 z = 0
	 
     For i = 1 To sf.Len(message) Step 2
	   karak = sf.Mid(message,i,1)
       z = z + sf.val(karak)
	 Next  
	 z = z * 3
     For i = 2 To sf.Len(message) - 1 Step 2
	   karak = sf.Mid(message,i,1)
       z = z + sf.val(karak)
	 Next  
     z = ((Floor(z/10) + 1)*10) - z
	 If z = 0 OR z = 10 Then message = message & "0"
	 If z = 1 Then message = message & "1"
	 If z = 2 Then message = message & "2"
	 If z = 3 Then message = message & "3"
	 If z = 4 Then message = message & "4"
	 If z = 5 Then message = message & "5"
	 If z = 6 Then message = message & "6"
	 If z = 7 Then message = message & "7"
	 If z = 8 Then message = message & "8"
	 If z = 9 Then message = message & "9"

	 build_string(message)
 
   End If
    
   If flag1 = 0 AND flag2 = 0 Then              'valid digits and an even number of input digits
   
     Dim z As Double
	 Dim karak As String
	 message = "0" & message                    'make the input message uneven so that we can calculate a check digit to mak the number of digits even
	 z = 0
	 
     For i = 1 To sf.Len(message) Step 2
	   karak = sf.Mid(message,i,1)
       z = z + sf.val(karak)
	 Next  
	 z = z * 3
     For i = 2 To sf.Len(message) - 1 Step 2
	   karak = sf.Mid(message,i,1)
       z = z + sf.val(karak)
	 Next  
     z = ((Floor(z/10) + 1)*10) - z
	 If z = 0 OR z = 10 Then message = message & "0"
	 If z = 1 Then message = message & "1"
	 If z = 2 Then message = message & "2"
	 If z = 3 Then message = message & "3"
	 If z = 4 Then message = message & "4"
	 If z = 5 Then message = message & "5"
	 If z = 6 Then message = message & "6"
	 If z = 7 Then message = message & "7"
	 If z = 8 Then message = message & "8"
	 If z = 9 Then message = message & "9"
 
     build_string(message)
   End If
   
   Return flag1
 
End Sub

Private Sub build_string(message As String)

Dim karak As String
bs = ""
start = "NNNN"	
bs = bs & start

For i = 1 To sf.Len(message) Step 2
    karak = sf.Mid(message,i,2)
 	If karak = "00" Then bs = bs &   "NNNNWWWWNN" 
	If karak = "01" Then bs = bs &	 "NWNNWNWNNW" 
	If karak = "02" Then bs = bs &	 "NNNWWNWNNW" 
	If karak = "03" Then bs = bs &	 "NWNWWNWNNN" 
	If karak = "04" Then bs = bs &	 "NNNNWWWNNW" 
	If karak = "05" Then bs = bs &	 "NWNNWWWNNN" 
	If karak = "06" Then bs = bs &	 "NNNWWWWNNN" 
	If karak = "07" Then bs = bs &	 "NNNNWNWWNW" 
	If karak = "08" Then bs = bs &	 "NWNNWNWWNN" 
	If karak = "09" Then bs = bs &	 "NNNWWNWWNN" 
	If karak = "10" Then bs = bs &	 "WNNNNWNWWN" 
	If karak = "11" Then bs = bs &	 "WWNNNNNNWW" 
	If karak = "12" Then bs = bs &	 "WNNWNNNNWW" 
	If karak = "13" Then bs = bs &	 "WWNWNNNNWN" 
	If karak = "14" Then bs = bs &	 "WNNNNWNNWW" 
	If karak = "15" Then bs = bs &	 "WWNNNWNNWN" 
	If karak = "16" Then bs = bs &	 "WNNWNWNNWN" 
	If karak = "17" Then bs = bs &	 "WNNNNNNWWW" 
	If karak = "18" Then bs = bs &	 "WWNNNNNWWN" 
	If karak = "19" Then bs = bs &	 "WNNWNNNWWN" 
	If karak = "20" Then bs = bs &	 "NNWNNWNWWN" 
	If karak = "21" Then bs = bs &	 "NWWNNNNNWW" 
	If karak = "22" Then bs = bs &	 "NNWWNNNNWW" 
	If karak = "23" Then bs = bs &	 "NWWWNNNNWN" 
	If karak = "24" Then bs = bs &	 "NNWNNWNNWW" 
	If karak = "25" Then bs = bs &	 "NWWNNWNNWN" 
	If karak = "26" Then bs = bs &	 "NNWWNWNNWN" 
	If karak = "27" Then bs = bs &	 "NNWNNNNWWW" 
	If karak = "28" Then bs = bs &	 "NWWNNNNWWN" 
	If karak = "29" Then bs = bs &	 "NNWWNNNWWN" 
	If karak = "30" Then bs = bs &	 "WNWNNWNWNN" 
	If karak = "31" Then bs = bs &	 "WWWNNNNNNW" 
	If karak = "32" Then bs = bs &	 "WNWWNNNNNW" 
	If karak = "33" Then bs = bs &	 "WWWWNNNNNN" 
	If karak = "34" Then bs = bs &	 "WNWNNWNNNW" 
	If karak = "35" Then bs = bs &	 "WWWNNWNNNN" 
	If karak = "36" Then bs = bs &	 "WNWWNWNNNN" 
	If karak = "37" Then bs = bs &	 "WNWNNNNWNW" 
	If karak = "38" Then bs = bs &	 "WWWNNNNWNN" 
	If karak = "39" Then bs = bs &	 "WNWWNNNWNN" 
	If karak = "40" Then bs = bs &	 "NNNNWWNWWN" 
	If karak = "41" Then bs = bs &	 "NWNNWNNNWW" 
	If karak = "42" Then bs = bs &	 "NNNWWNNNWW" 
	If karak = "43" Then bs = bs &	 "NWNWWNNNWN" 
	If karak = "44" Then bs = bs &	 "NNNNWWNNWW" 
	If karak = "45" Then bs = bs &	 "NWNNWWNNWN" 
	If karak = "46" Then bs = bs &	 "NNNWWWNNWN" 
	If karak = "47" Then bs = bs &	 "NNNNWNNWWW" 
	If karak = "48" Then bs = bs &	 "NWNNWNNWWN" 
	If karak = "49" Then bs = bs &	 "NNNWWNNWWN" 
	If karak = "50" Then bs = bs &	 "WNNNWWNWNN" 
	If karak = "51" Then bs = bs &	 "WWNNWNNNNW" 
	If karak = "52" Then bs = bs &	 "WNNWWNNNNW" 
	If karak = "53" Then bs = bs &	 "WWNWWNNNNN" 
	If karak = "54" Then bs = bs &	 "WNNNWWNNNW" 
	If karak = "55" Then bs = bs &	 "WWNNWWNNNN" 
	If karak = "56" Then bs = bs &	 "WNNWWWNNNN" 
	If karak = "57" Then bs = bs &	 "WNNNWNNWNW" 
	If karak = "58" Then bs = bs &	 "WWNNWNNWNN" 
	If karak = "59" Then bs = bs &	 "WNNWWNNWNN" 
	If karak = "60" Then bs = bs &	 "NNWNWWNWNN" 
	If karak = "61" Then bs = bs &	 "NWWNWNNNNW" 
	If karak = "62" Then bs = bs &	 "NNWWWNNNNW" 
	If karak = "63" Then bs = bs &	 "NWWWWNNNNN" 
	If karak = "64" Then bs = bs &	 "NNWNWWNNNW" 
	If karak = "65" Then bs = bs &	 "NWWNWWNNNN" 
	If karak = "66" Then bs = bs &	 "NNWWWWNNNN" 
	If karak = "67" Then bs = bs &	 "NNWNWNNWNW" 
	If karak = "68" Then bs = bs &	 "NWWNWNNWNN" 
	If karak = "69" Then bs = bs &	 "NNWWWNNWNN" 
	If karak = "70" Then bs = bs &	 "NNNNNWWWWN" 
	If karak = "71" Then bs = bs &	 "NWNNNNWNWW" 
	If karak = "72" Then bs = bs &	 "NNNWNNWNWW" 
	If karak = "73" Then bs = bs &	 "NWNWNNWNWN" 
	If karak = "74" Then bs = bs &	 "NNNNNWWNWW" 
	If karak = "75" Then bs = bs &	 "NWNNNWWNWN" 
	If karak = "76" Then bs = bs &	 "NNNWNWWNWN" 
	If karak = "77" Then bs = bs &	 "NNNNNNWWWW" 
	If karak = "78" Then bs = bs &	 "NWNNNNWWWN" 
	If karak = "79" Then bs = bs &	 "NNNWNNWWWN" 
	If karak = "80" Then bs = bs &	 "WNNNNWWWNN" 
	If karak = "81" Then bs = bs &	 "WWNNNNWNNW" 
	If karak = "82" Then bs = bs &	 "WNNWNNWNNW" 
	If karak = "83" Then bs = bs &	 "WWNWNNWNNN" 
	If karak = "84" Then bs = bs &	 "WNNNNWWNNW" 
	If karak = "85" Then bs = bs &	 "WWNNNWWNNN" 
	If karak = "86" Then bs = bs &	 "WNNWNWWNNN" 
	If karak = "87" Then bs = bs &	 "WNNNNNWWNW" 
	If karak = "88" Then bs = bs &	 "WWNNNNWWNN" 
	If karak = "89" Then bs = bs &	 "WNNWNNWWNN" 
	If karak = "90" Then bs = bs &	 "NNWNNWWWNN" 
	If karak = "91" Then bs = bs &	 "NWWNNNWNNW" 
	If karak = "92" Then bs = bs &	 "NNWWNNWNNW" 
	If karak = "93" Then bs = bs &	 "NWWWNNWNNN" 
	If karak = "94" Then bs = bs &	 "NNWNNWWNNW" 
	If karak = "95" Then bs = bs &	 "NWWNNWWNNN" 
	If karak = "96" Then bs = bs &	 "NNWWNWWNNN" 
	If karak = "97" Then bs = bs &	 "NNWNNNWWNW" 
	If karak = "98" Then bs = bs &	 "NWWNNNWWNN" 
	If karak = "99" Then bs = bs &	 "NNWWNNWWNN" 
Next	

fin = "WNN"	
bs = bs & fin

'Log(bs)

teken(message)
End Sub

Private Sub teken (message As String)

Dim b1 As Bitmap
Dim siz1 As Int
Dim qr_size As Int
siz1 = 9dip

qr_size = 0
For i = 1 To sf.len(bs)
  If sf.Mid(bs,i,1) = "N" Then qr_size = qr_size + siz1
  If sf.Mid(bs,i,1) = "W" Then qr_size = qr_size + (3*siz1) 
Next

b1.InitializeMutable(qr_size + 150dip ,Floor(qr_size / 3) + 150dip)      'This will set a border of 20dip around the image
                                                                   
Dim c As Canvas
Dim x As Int
Dim y As Int

c.initialize2(b1)
rect1.Initialize(0, 0, 0, 0)
rect1.Left = 0                                          'Set the size of the drawing area and fill it with WHITE
rect1.Right = qr_size + 150dip        
rect1.Top = 0            
rect1.Bottom = Floor(qr_size / 3) + 150dip        

c.DrawRect(rect1,bcolor,True,0)

x = 75dip     
y = 20dip  
		 
		 
For i = 1 To sf.len(bs)
  If i Mod 2 = 1  AND sf.Mid(bs,i,1) = "N" Then
	rect1.Left = x       
	rect1.Right = x + siz1            
	rect1.Top = y            
	rect1.Bottom = Floor(qr_size / 3) + 75dip           	 
    c.DrawRect(rect1, fcolor, True, 5dip)  
    x = x + siz1
  Else If i Mod 2 = 1  AND sf.Mid(bs,i,1) = "W" Then
	rect1.Left = x       
	rect1.Right = x + (3*siz1)            
	rect1.Top = y            
	rect1.Bottom = Floor(qr_size / 3) + 75dip         	 
    c.DrawRect(rect1, fcolor, True, 5dip)  
    x = x + (3 * siz1)
  Else If i Mod 2 = 0  AND sf.Mid(bs,i,1) = "N" Then
	rect1.Left = x       
	rect1.Right = x + siz1            
	rect1.Top = y            
	rect1.Bottom = Floor(qr_size / 3) + 75dip          	 
    c.DrawRect(rect1, bcolor, True, 5dip)  
    x = x + siz1
   Else If i Mod 2 = 0  AND sf.Mid(bs,i,1) = "W" Then
	rect1.Left = x       
	rect1.Right = x + (3*siz1)            
	rect1.Top = y            
	rect1.Bottom = Floor(qr_size / 3) + 75dip           	 
    c.DrawRect(rect1, bcolor, True, 5dip) 
	x = x + (3 * siz1)
   End If
Next

Dim stretch_mess As String
stretch_mess = "     "

For i=1 To sf.Len(message)
  stretch_mess = stretch_mess & sf.Mid(message,i,1)
  If i < sf.Len(message) Then
    stretch_mess = stretch_mess & "      "
  End If	
Next  

c.DrawText(stretch_mess,Floor(qr_size+150)/2, Floor(qr_size / 3) + 130dip,Typeface.DEFAULT_BOLD,35,Colors.Black,"CENTER")
'See Erel's posting at http://www.basic4ppc.com/android/forum/threads/saving-a-picture.10200/#post-56686 for detail of the code below
'Marginally changed to suite my requirements

Dim out As OutputStream
out = File.OpenOutput(File.DirRootExternal, "/pictures/Code25I.png", False)
b1.WriteToStream(out, 100, "PNG")                                           'Export the generated bitmap to a PNG and save in in the pictures folder
out.flush                                                                   'Make sure nothing is stuck that should have been written
out.Close

'send the intent that asks the media scanner to scan the file
Dim a123 As Intent
a123.Initialize("android.intent.action.MEDIA_SCANNER_SCAN_FILE", _
    "file://" & File.Combine(File.DirRootExternal, "/pictures/Code25I.png"))   '...so that the file is visible....    
Dim p As Phone
p.SendBroadcastIntent(a123)  
  
  


End Sub


