﻿Type=StaticCode
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
 Private Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private start As String
	Private fin As String
	Private sf As StringFunctions
	Private bs As String
	Private rect1 As Rect
	Private bcolor As Int
	Private fcolor As Int

End Sub

'Description: Generates Code39 barcode and saves it in the /pictures folder as "Code39.png" from where it can be loaded into for eg an ImageView
'
'Method of calling:
'success = Code39.Draw_Code39(message, back_color, front_color)
'
'where 'success' = indication of successful encoding (0 = successful, 1 = not successful) - type Int
'successful = all input chars are valid input chars (lower case will automatically be converted to upper case)
'where 'message' = message to be encoded - type String
'where 'back_color' = background color of the code - type Int
'where 'front_color' = foreground color of the code (solid bar color) - type Int
'example of parameters to pass:
'message = "Test Code39" 
'back_color = Colors.Yellow
'fore_color = Colors.Black
Public Sub Draw_Code39 (message As String, back_color As Int, front_color As Int) As Int

Dim flag As Int
sf.Initialize()
bcolor = back_color
fcolor = front_color
Dim karak, new_mes As String

new_mes = ""
flag = 0
For i = 1 To sf.Len(message) 
    karak = sf.Mid(message,i,1)
	If karak = "a" Then karak = "A"
	If karak = "b" Then karak = "B"
    If karak = "c" Then karak = "C"
	If karak = "d" Then karak = "D"
	If karak = "e" Then karak = "E"
	If karak = "f" Then karak = "F"
	If karak = "g" Then karak = "G"
	If karak = "h" Then karak = "H"
	If karak = "i" Then karak = "I"
	If karak = "j" Then karak = "J"
	If karak = "k" Then karak = "K"
	If karak = "l" Then karak = "L"
	If karak = "m" Then karak = "M"
	If karak = "n" Then karak = "N"
	If karak = "o" Then karak = "O"
	If karak = "p" Then karak = "P"
	If karak = "q" Then karak = "Q"
	If karak = "r" Then karak = "R"
	If karak = "s" Then karak = "S"
	If karak = "t" Then karak = "T"
	If karak = "u" Then karak = "U"
	If karak = "v" Then karak = "V"
	If karak = "w" Then karak = "W"
	If karak = "x" Then karak = "X"
	If karak = "y" Then karak = "Y"
	If karak = "z" Then karak = "Z"
	If karak <> "0" AND karak <> "1" AND karak <> "2" AND _
	   karak <> "3" AND karak <> "4" AND karak <> "5" AND _
	   karak <> "6" AND karak <> "7" AND karak <> "8" AND _
	   karak <> "9" AND karak <> "A" AND karak <> "B" AND _
	   karak <> "C" AND karak <> "D" AND karak <> "E" AND _
	   karak <> "F" AND karak <> "G" AND karak <> "H" AND _
	   karak <> "I" AND karak <> "J" AND karak <> "K" AND _
	   karak <> "L" AND karak <> "M" AND karak <> "N" AND _
	   karak <> "O" AND karak <> "P" AND karak <> "Q" AND _
	   karak <> "R" AND karak <> "S" AND karak <> "T" AND _
	   karak <> "U" AND karak <> "V" AND karak <> "W" AND _
	   karak <> "X" AND karak <> "Y" AND karak <> "Z" AND _
	   karak <> "-" AND karak <> "." AND karak <> " " AND _
	   karak <> "$" AND karak <> "/" AND karak <> "+" AND _
	   karak <> "%" Then
	   flag = 1
	   Exit
    End If
	new_mes = new_mes & karak
Next	

message = new_mes

'Log(message)
If flag = 0 Then
  build_string(message)
End If

If flag = 1 Then
  ToastMessageShow ("You are attempting to encode invalid Code39 characters", False)
End If
   
Return flag
 
End Sub


Private Sub build_string(message As String)

Dim karak As String
bs = ""
start = "NWNNWNWNN"	
bs = bs & start
bs = bs & "N"

For i = 1 To sf.Len(message) 
    karak = sf.Mid(message,i,1)
'	Log(karak)
	If karak = "0" Then bs = bs & "NNNWWNWNN"
	If karak = "1" Then bs = bs & "WNNWNNNNW"
	If karak = "2" Then bs = bs & "NNWWNNNNW"
	If karak = "3" Then bs = bs & "WNWWNNNNN"
	If karak = "4" Then bs = bs & "NNNWWNNNW"
	If karak = "5" Then bs = bs & "WNNWWNNNN"
	If karak = "6" Then bs = bs & "NNWWWNNNN"
	If karak = "7" Then bs = bs & "NNNWNNWNW"
	If karak = "8" Then bs = bs & "WNNWNNWNN"
	If karak = "9" Then bs = bs & "NNWWNNWNN"
	If karak = "A" Then bs = bs & "WNNNNWNNW"
	If karak = "B" Then bs = bs & "NNWNNWNNW"
	If karak = "C" Then bs = bs & "WNWNNWNNN"
	If karak = "D" Then bs = bs & "NNNNWWNNW"
	If karak = "E" Then bs = bs & "WNNNWWNNN"
	If karak = "F" Then bs = bs & "NNWNWWNNN"
	If karak = "G" Then bs = bs & "NNNNNWWNW"
	If karak = "H" Then bs = bs & "WNNNNWWNN"
	If karak = "I" Then bs = bs & "NNWNNWWNN"
	If karak = "J" Then bs = bs & "NNNNWWWNN"
	If karak = "K" Then bs = bs & "WNNNNNNWW"
	If karak = "L" Then bs = bs & "NNWNNNNWW"
	If karak = "M" Then bs = bs & "WNWNNNNWN"
	If karak = "N" Then bs = bs & "NNNNWNNWW"
	If karak = "O" Then bs = bs & "WNNNWNNWN"
	If karak = "P" Then bs = bs & "NNWNWNNWN"
	If karak = "Q" Then bs = bs & "NNNNNNWWW"
	If karak = "R" Then bs = bs & "WNNNNNWWN"
	If karak = "S" Then bs = bs & "NNWNNNWWN"
	If karak = "T" Then bs = bs & "NNNNWNWWN"
	If karak = "U" Then bs = bs & "WWNNNNNNW"
	If karak = "V" Then bs = bs & "NWWNNNNNW"
	If karak = "W" Then bs = bs & "WWWNNNNNN"
	If karak = "X" Then bs = bs & "NWNNWNNNW"
	If karak = "Y" Then bs = bs & "WWNNWNNNN"
	If karak = "Z" Then bs = bs & "NWWNWNNNN"
	If karak = "-" Then bs = bs & "NWNNNNWNW"
	If karak = "." Then bs = bs & "WWNNNNWNN"
	If karak = " " Then bs = bs & "NWWNNNWNN"
	If karak = "$" Then bs = bs & "NWNWNWNNN"
	If karak = "/" Then bs = bs & "NWNWNNNWN"
	If karak = "+" Then bs = bs & "NWNNNWNWN"
	If karak = "%" Then bs = bs & "NNNWNWNWN"
	bs = bs & "N" 
Next	

fin = "NWNNWNWNN"	
bs = bs & fin

'Log(bs)

teken(message)
End Sub

Private Sub teken (message As String)

Dim b1 As Bitmap
Dim siz1 As Int
Dim qr_size As Int
siz1 = 9dip

qr_size = 0
For i = 1 To sf.len(bs)
  If sf.Mid(bs,i,1) = "N" Then qr_size = qr_size + siz1
  If sf.Mid(bs,i,1) = "W" Then qr_size = qr_size + (2*siz1) 
Next

b1.InitializeMutable(qr_size + 150dip ,Floor(qr_size / 3) + 150dip)      'This will set a border of 20dip around the image
                                                                   
Dim c As Canvas
Dim x As Int
Dim y As Int

c.initialize2(b1)
rect1.Initialize(0, 0, 0, 0)
rect1.Left = 0                                          'Set the size of the drawing area and fill it with WHITE
rect1.Right = qr_size + 150dip        
rect1.Top = 0            
rect1.Bottom = Floor(qr_size / 3) + 150dip        

c.DrawRect(rect1,bcolor,True,0)

'x = Floor (((qr_size  + 150dip) - (qr_size))/2)     'Find the centre points and step back to make it appear centre in the PNG file 
x = 75dip     
y = 20dip  
		 
		 
For i = 1 To sf.len(bs)
  If i Mod 2 = 1  AND sf.Mid(bs,i,1) = "N" Then
	rect1.Left = x       
	rect1.Right = x + siz1            
	rect1.Top = y            
	rect1.Bottom = Floor(qr_size / 3) + 50dip           	 
    c.DrawRect(rect1, fcolor, True, 5dip)  
    x = x + siz1
  Else If i Mod 2 = 1  AND sf.Mid(bs,i,1) = "W" Then
	rect1.Left = x       
	rect1.Right = x + (2*siz1)            
	rect1.Top = y            
	rect1.Bottom = Floor(qr_size / 3) + 50dip         	 
    c.DrawRect(rect1, fcolor, True, 5dip)  
    x = x + (2 * siz1)
  Else If i Mod 2 = 0  AND sf.Mid(bs,i,1) = "N" Then
	rect1.Left = x       
	rect1.Right = x + siz1            
	rect1.Top = y            
	rect1.Bottom = Floor(qr_size / 3) + 50dip          	 
    c.DrawRect(rect1, bcolor, True, 5dip)  
    x = x + siz1
   Else If i Mod 2 = 0  AND sf.Mid(bs,i,1) = "W" Then
	rect1.Left = x       
	rect1.Right = x + (2*siz1)            
	rect1.Top = y            
	rect1.Bottom = Floor(qr_size / 3) + 50dip           	 
    c.DrawRect(rect1, bcolor, True, 5dip) 
	x = x + (2 * siz1)
   End If
Next

message = "*" & message & "*"
Dim stretch_mess As String
stretch_mess = "     "

For i=1 To sf.Len(message)
  stretch_mess = stretch_mess & sf.Mid(message,i,1)
  If i < sf.Len(message) Then
    stretch_mess = stretch_mess & "        "
  End If	
Next  

c.DrawText(stretch_mess,Floor(qr_size+150)/2, Floor(qr_size / 3) + 130dip,Typeface.DEFAULT_BOLD,45,Colors.Black,"CENTER")
'See Erel's posting at http://www.basic4ppc.com/android/forum/threads/saving-a-picture.10200/#post-56686 for detail of the code below
'Marginally changed to suite my requirements

Dim out As OutputStream
out = File.OpenOutput(File.DirRootExternal, "/pictures/Code39.png", False)
b1.WriteToStream(out, 100, "PNG")                                           'Export the generated bitmap to a PNG and save in in the pictures folder
out.flush                                                                   'Make sure nothing is stuck that should have been written
out.Close

'send the intent that asks the media scanner to scan the file
Dim a123 As Intent
a123.Initialize("android.intent.action.MEDIA_SCANNER_SCAN_FILE", _
    "file://" & File.Combine(File.DirRootExternal, "/pictures/Code39.png"))   '...so that the file is visible....    
Dim p As Phone
p.SendBroadcastIntent(a123)  
  
End Sub

