﻿Type=StaticCode
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
 Private Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Private start As String
	Private fin As String
	Private sf As StringFunctions
	Private bs As String
	Private rect1 As Rect
	Private bcolor As Int
	Private fcolor As Int

End Sub

'Description: Generates a EAN-8 barcode and saves it in the /pictures folder as "EAN8.png" from where it can be loaded into for eg an ImageView
'
'Method of calling:
'success = EAN8.Draw_EAN8(message, back_color, fore_color)
'
'where 'success' = indication of successful encoding (0 = successful, 1 = not successful) - type Int
'successful = all input chars are numbers only
'where 'message' = message to be encoded - type String (enter first 7 characters only. The check digit (8th char) will be calculated and added)
'where 'back_color' = background color of the code - type Int
'where 'fore_color' = foreground color of the code (solid bar color) - type Int
'example of parameters to pass:
'message = "5512345" - the message excludes the check digit that will be added
'back_color = Colors.Yellow
'fore_color = Colors.Black
Public Sub Draw_EAN8 (message As String, back_color As Int, front_color As Int) As Int

  Dim flag1, flag2 As Int
  sf.Initialize()
  bcolor = back_color
  fcolor = front_color

  flag1 = 0
  flag2 = 0
  If sf.len(message) <> 7 Then                'not the right number of digits
    ToastMessageShow ("You have entered the incorrect number of digits", False) 
    flag2 = 1
  End If  
  
  For i = 1 To sf.Len(message)
      If sf.Mid(message,i,1) <> "0" AND _
	     sf.Mid(message,i,1) <> "1" AND _
		 sf.Mid(message,i,1) <> "2" AND _
		 sf.Mid(message,i,1) <> "3" AND _
		 sf.Mid(message,i,1) <> "4" AND _
		 sf.Mid(message,i,1) <> "5" AND _
		 sf.Mid(message,i,1) <> "6" AND _
		 sf.Mid(message,i,1) <> "7" AND _
		 sf.Mid(message,i,1) <> "8" AND _
		 sf.Mid(message,i,1) <> "9"  Then
		 flag1 = 1
		 Exit
	  End If	   
	Next 
 
    If flag1 = 1 Then
   	  ToastMessageShow ("You are attempting to encode non-numeric characters", False)
    End If

   If flag1 = 0 AND flag2 = 0 Then                    'calculate and add a checksum for the 8th digit
     Dim z As Double
	 z = 0

    For i = 1 To sf.len(message)
	  If i Mod 2 = 1 Then
	    z = z + (sf.Val(sf.Mid(message,i,1)) * 3)
      Else
	    z = z + (sf.Val(sf.Mid(message,i,1)) * 1)  
	  End If
	Next  
	
     z = ((Floor(z/10) + 1)*10) - z
	 If z = 0 OR z = 10 Then message = message & "0"
	 If z = 1 Then message = message & "1"
	 If z = 2 Then message = message & "2"
	 If z = 3 Then message = message & "3"
	 If z = 4 Then message = message & "4"
	 If z = 5 Then message = message & "5"
	 If z = 6 Then message = message & "6"
	 If z = 7 Then message = message & "7"
	 If z = 8 Then message = message & "8"
	 If z = 9 Then message = message & "9"




'    Log(message)
	build_string(message)
   End If
   
   Return Bit.OR(flag1,flag2)
  
End Sub

Private Sub build_string(message As String)

Dim karak As String
bs = ""
start = "101"	
bs = bs & start
Private ver() As String
'First                 Second  M1     M2     M3      M4    M5
ver = Array As String("Odd", "Odd", "Odd", "Odd" ,"Odd", "Odd", _
                      "Odd", "Odd", "Even", "Odd", "Even", "Even", _
                      "Odd", "Odd", "Even", "Even", "Odd", "Even", _
                      "Odd", "Odd", "Even", "Even", "Even", "Odd", _
                      "Odd", "Even", "Odd", "Odd", "Even", "Even", _
                      "Odd", "Even", "Even", "Odd", "Odd", "Even", _
                      "Odd", "Even", "Even", "Even", "Odd", "Odd", _
                      "Odd", "Even", "Odd", "Even", "Odd", "Even", _
                      "Odd", "Even", "Odd", "Even", "Even", "Odd", _
                      "Odd", "Even", "Even", "Odd", "Even", "Odd")


Private str()As String
                       '  ODD     EVEN       ALL
                       '  LEFT    LEFT      RIGHT
str = Array As String("0001101","0100111","1110010", _
                      "0011001","0110011","1100110", _
                      "0010011","0011011","1101100", _
                      "0111101","0100001","1000010", _
                      "0100011","0011101","1011100", _
                      "0110001","0111001","1001110", _ 
                      "0101111","0000101","1010000", _ 
                      "0111011","0010001","1000100", _ 
                      "0110111","0001001","1001000", _ 
                      "0001011","0010111","1110100") 

Dim first_num, karak_val As Int
first_num = sf.Val(sf.Mid(message,1,1))


'Log("first_num")
'Log(first_num)
   karak = sf.Mid(message,1,1)
   karak_val = sf.Val(karak)
   bs = bs & str(karak_val * 3)

   karak = sf.Mid(message,2,1)
   karak_val = sf.Val(karak)
   bs = bs & str(karak_val * 3)
   
   karak = sf.Mid(message,3,1)
   karak_val = sf.Val(karak)
   bs = bs & str(karak_val * 3)
   
   karak = sf.Mid(message,4,1)
   karak_val = sf.Val(karak)
   bs = bs & str(karak_val * 3)
   
   bs = bs & "01010"

   karak = sf.Mid(message,5,1)
   karak_val = sf.Val(karak)
   bs = bs & str(karak_val * 3 + 2)   
   
   karak = sf.Mid(message,6,1)
   karak_val = sf.Val(karak)
   bs = bs & str(karak_val * 3 + 2)   
   
   karak = sf.Mid(message,7,1)
   karak_val = sf.Val(karak)
   bs = bs & str(karak_val * 3 + 2)   
   
   karak = sf.Mid(message,8,1)
   karak_val = sf.Val(karak)
   bs = bs & str(karak_val * 3 + 2)   
   
fin = "101"	
bs = bs & fin

teken(message)

End Sub

Private Sub teken (message As String)

Dim b1 As Bitmap
Dim siz1 As Int
Dim qr_size As Int
siz1 = 9dip

qr_size = 0
For i = 1 To sf.len(bs)
  qr_size = qr_size + siz1
Next

b1.InitializeMutable(qr_size + 40dip ,Floor(qr_size / 3) + 40dip)      'This will set a border of 20dip around the image
                                                                   
Dim c As Canvas
Dim x As Int
Dim y As Int

c.initialize2(b1)
rect1.Initialize(0, 0, 0, 0)
rect1.Left = 0                                          'Set the size of the drawing area and fill it with WHITE
rect1.Right = qr_size + 40dip        
rect1.Top = 0            
rect1.Bottom = Floor(qr_size / 3) + 40dip        

c.DrawRect(rect1,bcolor,True,0)

x = 10dip     
y = 3dip  
		 
		 
For i = 1 To sf.len(bs)
  If sf.Mid(bs,i,1) = "0" Then
	rect1.Left = x       
	rect1.Right = x + siz1            
	rect1.Top = y            
	rect1.Bottom = Floor(qr_size / 3) + 3dip           	 
    c.DrawRect(rect1, bcolor, True, 5dip)  
    x = x + siz1
  Else If sf.Mid(bs,i,1) = "1" Then
	rect1.Left = x       
	rect1.Right = x + siz1           
	rect1.Top = y
	If i = 1 OR i = 3 OR i = 65 OR i = 67 OR i = 33 OR i = 35 Then
	  rect1.Bottom = Floor(qr_size / 3) + 9dip  	
	Else
	  rect1.Bottom = Floor(qr_size / 3) + 3dip  
	End If  
    c.DrawRect(rect1, fcolor, True, 5dip)  
    x = x + siz1
  End If
Next

Dim stretch_mess As String
stretch_mess = ""

For i=1 To sf.Len(message)
  stretch_mess = stretch_mess & sf.Mid(message,i,1)
  If i < sf.Len(message) Then
    stretch_mess = stretch_mess & "         "
  End If	
Next 

c.DrawText(stretch_mess,Floor(qr_size+20)/2, Floor(qr_size / 3) + 30dip,Typeface.DEFAULT_BOLD,25,Colors.Black,"CENTER")
'See Erel's posting at http://www.basic4ppc.com/android/forum/threads/saving-a-picture.10200/#post-56686 for detail of the code below
'Marginally changed to suite my requirements

Dim out As OutputStream
out = File.OpenOutput(File.DirRootExternal, "/pictures/EAN8.png", False)
b1.WriteToStream(out, 100, "PNG")                                           'Export the generated bitmap to a PNG and save in in the pictures folder
out.flush                                                                   'Make sure nothing is stuck that should have been written
out.Close

'send the intent that asks the media scanner to scan the file
Dim a123 As Intent
a123.Initialize("android.intent.action.MEDIA_SCANNER_SCAN_FILE", _
    "file://" & File.Combine(File.DirRootExternal, "/pictures/EAN8.png"))   '...so that the file is visible....    
Dim p As Phone
p.SendBroadcastIntent(a123)  

End Sub